# -*- coding: utf-8 -*-
"""
Created on Fri Dec 15 12:31:42 2017

@author: Darin
"""

import numpy as np
import matplotlib.pyplot as plt
import NURBS

def Plot_Shape(Ellist, Node, u=[]):
    xi = np.linspace(0,1-1e-15,31)
    plt.figure(figsize=(10,10))
    for el in Ellist:
        coord = NURBS.NURBS(xi, el.knots, Node[:,el.cp])
        plt.plot(coord[0,:], coord[1,:], 'k', linewidth=3)
    plt.axis('off')
    if len(u) > 0:
        width = max(np.max(Node[0,:])-np.min(Node[0,:]),np.max(Node[1,:])-np.min(Node[1,:]))
        DShape = Node + width/np.max(np.abs(u))*0.5*u.reshape((-1,2)).T
        for el in Ellist:
            coord = NURBS.NURBS(xi, el.knots, DShape[:,el.cp])
            plt.plot(coord[0,:], coord[1,:], 'r', alpha=0.5)
    plt.axis('equal')
    plt.show()

def Plot_Initial(Ellist, Node, fixdof, load):
    xi = np.linspace(0,1-1e-15,31)
    plt.figure(figsize=(10,10))
    for el in Ellist:
        coord = NURBS.NURBS(xi, el.knots, Node[:,el.cp])
        plt.plot(coord[0,:], coord[1,:], 'k', linewidth=3)
    plt.axis('off')
    for i in fixdof:
        if i % Node.shape[0] == 0:
            plt.plot(Node[0,fixdof//2], Node[1,fixdof//2], 'b>', markersize=12)
        else:
            plt.plot(Node[0,fixdof//2], Node[1,fixdof//2], 'g^', markersize=12)
    for i in load:
        if i % Node.shape[0] == 0:
            plt.plot(Node[0,load//2], Node[1,load//2], 'r>', markersize=12)
        else:
            plt.plot(Node[0,load//2], Node[1,load//2], 'm^', markersize=12)
    plt.axis('equal')
    plt.show()